SystemOrganization addCategory: #ConfigurationOfPhriak!

Object subclass: #ConfigurationOfPhriak
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfPhriak'!

!ConfigurationOfPhriak class methodsFor: 'development support' stamp: 'NicolasPetton 2/3/2012 21:05'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfPhriak class methodsFor: 'private' stamp: 'NicolasPetton 2/3/2012 21:05'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfPhriak class methodsFor: 'private' stamp: 'NicolasPetton 2/3/2012 21:05'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfPhriak class methodsFor: 'private' stamp: 'NicolasPetton 2/3/2012 21:05'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfPhriak class methodsFor: 'metacello tool support' stamp: 'NicolasPetton 2/3/2012 21:05'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfPhriak class methodsFor: 'loading' stamp: 'NicolasPetton 2/3/2012 21:05'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfPhriak class methodsFor: 'loading' stamp: 'NicolasPetton 2/3/2012 21:05'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfPhriak class methodsFor: 'loading' stamp: 'NicolasPetton 2/3/2012 21:05'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfPhriak class methodsFor: 'accessing' stamp: 'NicolasPetton 2/3/2012 21:05'!
project

	^self new project! !

!ConfigurationOfPhriak class methodsFor: 'development support' stamp: 'NicolasPetton 2/3/2012 21:05'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfPhriak methodsFor: 'baselines' stamp: 'NicolasPetton 2/3/2012 21:14'!
baseline01: spec
	<version: '0.1-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://www.squeaksource.com/Phriak'.
		spec package: 'Phriak'.
	
	spec
			project: 'ZincHTTPComponents' with: [
				spec
					className: 'ConfigurationOfZincHTTPComponents';
					loads: #('Zinc-HTTP' );
					file: 'ConfigurationOfZincHTTPComponents';
					repository: 'http://www.squeaksource.com/MetacelloRepository' ].	
	
	spec 
			repository: 'http://www.squeaksource.com/JSON';
			package: 'JSON'].
! !

!ConfigurationOfPhriak methodsFor: 'symbolic versions' stamp: 'NicolasPetton 2/3/2012 21:05'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '0.1'.
! !

!ConfigurationOfPhriak methodsFor: 'accessing' stamp: 'NicolasPetton 2/3/2012 21:05'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfPhriak methodsFor: 'symbolic versions' stamp: 'NicolasPetton 2/3/2012 21:08'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '0.1'.
! !

!ConfigurationOfPhriak methodsFor: 'versions' stamp: 'NicolasPetton 2/4/2012 18:16'!
version01: spec
	<version: '0.1' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: 'initial version'.
		spec author: 'NicolasPetton'.
		spec timestamp: '2/3/2012 21:05'.
		spec package: 'Phriak' with: 'Phriak-NicolasPetton.25'. 
		spec project: 'ZincHTTPComponents' with: '1.3'.
		spec package: 'JSON' with: 'JSON-ul.35'].
! !
